package com.ruoyi.biz.service.impl;

import java.util.List;
import java.util.UUID;

import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SnowFlakeUtils;
import com.ruoyi.common.utils.SecurityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.biz.mapper.BizPatentValidOgMapper;
import com.ruoyi.biz.domain.BizPatentValidOg;
import com.ruoyi.biz.service.IBizPatentValidOgService;

/**
 * 专利有效原始Service业务层处理
 * 
 * @author dm
 * @date 2023-03-09
 */
@Service
@Transactional
public class BizPatentValidOgServiceImpl implements IBizPatentValidOgService 
{
    @Autowired
    private BizPatentValidOgMapper bizPatentValidOgMapper;

    /**
     * 查询专利有效原始
     * 
     * @param id 专利有效原始主键
     * @return 专利有效原始
     */
    @Override
    public BizPatentValidOg selectBizPatentValidOgById(String id)
    {
        return bizPatentValidOgMapper.selectBizPatentValidOgById(id);
    }

    /**
     * 查询专利有效原始列表
     * 
     * @param bizPatentValidOg 专利有效原始
     * @return 专利有效原始
     */
    @Override
    public List<BizPatentValidOg> selectBizPatentValidOgList(BizPatentValidOg bizPatentValidOg)
    {
        return bizPatentValidOgMapper.selectBizPatentValidOgList(bizPatentValidOg);
    }

    /**
     * 新增专利有效原始
     * 
     * @param bizPatentValidOg 专利有效原始
     * @return 结果
     */
    @Override
    public int insertBizPatentValidOg(BizPatentValidOg bizPatentValidOg)
    {
        if(bizPatentValidOg.getId()==null){
        bizPatentValidOg.setId(UUID.randomUUID().toString().replace("-",""));
    }
        bizPatentValidOg.setCreateTime(DateUtils.getNowDate());
        return bizPatentValidOgMapper.insertBizPatentValidOg(bizPatentValidOg);
    }

    /**
     * 修改专利有效原始
     * 
     * @param bizPatentValidOg 专利有效原始
     * @return 结果
     */
    @Override
    public int updateBizPatentValidOg(BizPatentValidOg bizPatentValidOg)
    {
        return bizPatentValidOgMapper.updateBizPatentValidOg(bizPatentValidOg);
    }

    /**
     * 批量删除专利有效原始
     * 
     * @param ids 需要删除的专利有效原始主键
     * @return 结果
     */
    @Override
    public int deleteBizPatentValidOgByIds(String[] ids)
    {
        return bizPatentValidOgMapper.deleteBizPatentValidOgByIds(ids);
    }

    /**
     * 删除专利有效原始信息
     * 
     * @param id 专利有效原始主键
     * @return 结果
     */
    @Override
    public int deleteBizPatentValidOgById(String id)
    {
        return bizPatentValidOgMapper.deleteBizPatentValidOgById(id);
    }

    /**
     * 批量---逻辑删除
     *
     * @param ids 需要删除的专利有效原始ID
     * @return 结果
     */
    @Override
    public int setDeleteByIds(String[] ids)
    {
        Long userId = SecurityUtils.getUserId();
        String userNickName = SecurityUtils.getUserNickName();
        return bizPatentValidOgMapper.setDeleteByIds(ids,userId,userNickName);
    }

    /**
     * 删除---逻辑删除
     *
     * @param id 专利有效原始ID
     * @return 结果
     */
    @Override
    public int setDeleteById(String id)
    {
        Long userId = SecurityUtils.getUserId();
        String userNickName = SecurityUtils.getUserNickName();
        return bizPatentValidOgMapper.setDeleteById(id,userId,userNickName);
    }

    /**
     * 导入专利有效原始数据
     *
     * @param bizPatentValidOgList 专利有效原始列表
     * @param operName 操作用户
     * @return 结果
     */
    public String importBizPatentValidOg(List<BizPatentValidOg> bizPatentValidOgList, String operName) {
        if (StringUtils.isNull(bizPatentValidOgList) || bizPatentValidOgList.size() == 0)
        {
            throw new ServiceException("导入专利有效数据不能为空！");
        }
        int successNum = bizPatentValidOgList.size();
        StringBuilder successMsg = new StringBuilder();
        successMsg.insert(0, "恭喜您，数据已全部导入成功！共 " + successNum + " 条");
        return successMsg.toString();
    }

}
